//This script takes care of jump related things. The jumpsphere, and the hop that you can do.
addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "modernsonic"
		and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			if player.homing 
				player.mo.state = S_PLAY_JUMP
			end
			if not (player.cmd.buttons & BT_JUMP)
				player.hopdown = false
			end
			if P_IsObjectOnGround(player.mo)
			or not (player.pflags & PF_JUMPED)
				player.justjumped = false
			end
			if player.pflags & PF_JUMPED
			and (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_WALLJUMP)
			and player.mo.state ~= S_PLAY_HOP
			and (player.jumptimer > 3 or player.pflags & PF_THOKKED)
			and player.playerstate == PST_LIVE
					local jumpsphere = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z-FixedMul(player.mo.height/5, P_GravAndScale(player.mo)), MT_JUMPSPHERE)
					jumpsphere.target = player.mo
					jumpsphere.skin = "modernsonic"
					jumpsphere.sprite = SPR_PLAY
					jumpsphere.sprite2 = SPR2_SPNR 
					jumpsphere.frame = player.mo.frame|FF_TRANS40|FF_FULLBRIGHT
					
					if jumpsphere.target.flags2 & MF2_DONTDRAW
						jumpsphere.flags2 = $1|MF2_DONTDRAW
					else
						jumpsphere.flags2 = $1 & ~MF2_DONTDRAW
					end
					jumpsphere.angle = player.drawangle
					A_CapeChase(jumpsphere)
					jumpsphere.scale = P_RandomRange(jumpsphere.target.scale+FixedMul(FRACUNIT/3, player.mo.scale), jumpsphere.target.scale+2*FixedMul(FRACUNIT/5, player.mo.scale))
					jumpsphere.color = jumpsphere.target.color
					jumpsphere.fuse = 1
			end
			if player.pflags & PF_JUMPED
			and not (player.powers[pw_carry])
			and not (player.mo.state == S_PLAY_ROLL)
			and not (player.pflags & PF_THOKKED)
			and player.stomping == false
			and player.mo.state ~= S_PLAY_FALL
			and player.mo.state ~= S_PLAY_SPRING
				player.jumptimer = $1+1
				if player.jumptimer <= 3
					player.mo.state = S_PLAY_HOP
				end
				if player.cmd.buttons & BT_JUMP
				and player.mo.state == S_PLAY_HOP
				and (player.jumptimer > 3)
				and player.hopdown == true
					if (player.mo.eflags & MFE_UNDERWATER)
						S_StartSound(player.mo, sfx_spnwtr)
					else
						S_StartSound(player.mo, sfx_airspn)
					end
					player.mo.state = S_PLAY_JUMP
				end
				if player.jumptimer > 3
				and player.mo.state == S_PLAY_FALL
					player.mo.state = S_PLAY_HOPFALL
				end
				if player.jumptimer > 0
					if player.mo.state == S_PLAY_HOP
					or player.mo.state == S_PLAY_HOPFALL
						player.pflags = $1|PF_NOJUMPDAMAGE
					else
						player.pflags = $1 & ~PF_NOJUMPDAMAGE
					end
				end
					
			else
				player.jumptimer = 0
			end
		end
	end
end)
				
//Takes care of the double jump/homing attack. Hope you like Sonic Colo(u)rs!		
addHook("AbilitySpecial", function(player)
	if player.mo.skin == "modernsonic"
	and player.pflags & PF_JUMPED
		if not (P_LookForEnemies(player))
			player.charability = CA_NONE
			if player.doublejumped == true
				local walljump = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_WALLJUMP)
				walljump.target = player.mo
				walljump.scale = player.mo.scale
			end
			if player.doublejumped == false
			and player.stomping == false
				player.jumpdown = true
				if (player.mo.eflags & MFE_UNDERWATER)
					if player.powers[pw_shield] == SH_WHIRLWIND
						P_SetObjectMomZ(player.mo, 5*FRACUNIT, false)
					else
						P_SetObjectMomZ(player.mo, 4*FRACUNIT, false)
					end
					local bubble = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_UWEXPLODE)
					bubble.scale = player.mo.scale
					S_StartSound(player.mo, sfx_spnwtr)
				else
					if player.powers[pw_shield] == SH_WHIRLWIND
						P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
					else
						P_SetObjectMomZ(player.mo, 8*FRACUNIT, false)
					end
					S_StartSound(player.mo, sfx_airspn)
					player.pflags = $1 & ~PF_SPINNING	
				end
				if player.speed > 15*FRACUNIT
				and not (player.powers[pw_super])
				and not (player.powers[pw_shield] == SH_WHIRLWIND)
					player.mo.momy = $1*5/8
					player.mo.momx = $1*5/8
				end
				player.pflags = $1 & ~PF_NOJUMPDAMAGE
				player.mo.state = S_PLAY_JUMP
				player.pflags = $1|PF_THOKKED
				player.doublejumped = true
				player.boosting = false
				for i = 1, 16 //spawn some dust yee
					local dust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + (player.mo.eflags & MFE_VERTICALFLIP and 4*player.mo.scale or 0), player.mo.eflags & (MFE_UNDERWATER | MFE_TOUCHWATER) and MT_MEDIUMBUBBLE or MT_PARTICLE)
					dust.fuse = TICRATE/4
					dust.scale = player.mo.scale
					dust.destscale = player.mo.scale/8
					dust.eflags = player.mo.eflags & MFE_VERTICALFLIP
					P_InstaThrust(dust, i*ANGLE_22h, 6*player.mo.scale)
					dust.momz = -2*P_MobjFlip(player.mo)*player.mo.scale
					dust.frame = $1|TR_TRANS60
				end
			end
		end
		if not (player.mo.eflags & MFE_UNDERWATER)
		and not (player.homing)
		and player.charability == CA_HOMINGTHOK
			S_StartSound(player.mo, sfx_mthok)
			if player.voices == 1
				PlayModernSound(player, TYPE_HOMINGATTACKJ)
			elseif player.voices == 2
				PlayModernSound(player, TYPE_HOMINGATTACKR)
			elseif player.voices == 3
				PlayModernSound(player, TYPE_HOMINGATTACKD)
			elseif player.voices == 4
				PlayModernSound(player, TYPE_FEELINGGOOD)	
			end
		else
			if (player.mo.eflags & MFE_UNDERWATER)
			and not (player.homing)
			and player.charability == CA_HOMINGTHOK
				S_StartSound(player.mo, sfx_mthokw)
			end
		end
	end
end)

//Plays grunts when the player jumps and handles the jump sound
addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "modernsonic"
			if player.homing
				player.charflags = $1 & ~SF_MULTIABILITY
			else
				player.charflags = $1|SF_MULTIABILITY
			end
			if player.homing
				if player.mo.target
					if player.mo.target.flags & MF_BOSS
					or player.mo.target.type == MT_PLAYER
						player.wasjusthoming = 2
					else
						player.wasjusthoming = 1
					end
				end
			elseif player.wasjusthoming > 0
				if player.wasjusthoming == 2
					player.doublejumped = true
				end
				player.wasjusthoming = 0
				player.homingacceltimer = TICRATE
			end
			if not (player.pflags & PF_JUMPED)
				player.wasjusthoming = 0
				player.homingacceltimer = 0
			end
			if player.homingacceltimer > 0
				player.homingacceltimer = $1-1
				player.accelstart = 170
				player.thrustfactor = 8
			else
				player.accelstart = skins[player.mo.skin].accelstart
				player.thrustfactor = skins[player.mo.skin].thrustfactor
			end
				
			if player.powers[pw_carry] 
				player.stomping = false
				player.airboost = false
				player.hopdown = false
				player.justjumped = false
				player.stomping = false
				player.walljumped = false
			end
			if P_IsObjectOnGround(player.mo)
			or not (player.pflags & PF_JUMPED)
				player.doublejumped = false
			end
			if P_IsObjectOnGround(player.mo)
				if player.mo.state == S_PLAY_FALL
				or player.mo.state == S_PLAY_HOPFALL
					player.mo.state = S_PLAY_STND
				end
			end
			if player.homing
				player.charability = CA_HOMINGTHOK
				player.doublejumped = false
			end
			if player.pflags & PF_JUMPED
			and not (P_IsObjectOnGround(player.mo))
			and not (player.homing)
				if P_LookForEnemies(player)
					player.charability = CA_HOMINGTHOK
				else
					player.charability = CA_NONE
				end
			end
			if player.pflags & PF_JUMPED
			and not (player.mo.state == S_PLAY_SPRING)
			and not (player.mo.state == S_PLAY_FALL)
			and player.airboost == false
			and player.hopdown == false
			and player.justjumped == false
			and player.stomping == false
			and player.walljumped == false
			and not (player.powers[pw_carry])
			and not (player.mo.state == S_PLAY_ROLL)
			and not (player.pflags & PF_THOKKED)
			and player.superboost == false
			and not P_IsObjectOnGround(player.mo)
				player.justjumped = true
				player.mo.state = S_PLAY_HOP
				player.hopdown = true
				if not (player.mo.eflags & MFE_UNDERWATER)
					S_StartSound(player.mo, sfx_mjump)
					if player.voices == 1
						PlayModernSound(player, TYPE_JUMPJ)
					elseif player.voices == 2
						PlayModernSound(player, TYPE_JUMPR)
					elseif player.voices == 3
						PlayModernSound(player, TYPE_JUMPD)
					elseif player.voices == 4
						PlayModernSound(player, TYPE_FEELINGGOOD)	
					end
				else 
					S_StartSound(player.mo, sfx_jumpwt)
				end
			end
		end
	end
end)