//Creates a new function that the lockon reticle will use.
function A_ReticleThinker (actor, var1, var2)
	//Use a variable to determine if the actor has a tracer
	actor.hastracer = false
	if (actor.tracer)
	and (actor.tracer.valid) then
		actor.hastracer = true
	end
	//If the actor has a target...
	if (actor.target)
	and (actor.target.valid) then
		//Turn visible
		actor.flags2 = $1 & ~MF2_DONTDRAW
		//Follow it
		P_TeleportMove(actor, actor.target.x, actor.target.y, actor.target.z)
		actor.momx = 0
		actor.momy = 0
		actor.momz = 0
		//Copy its attributes
		//actor.scale = actor.target.scale
		if actor.target.eflags & MFE_VERTICALFLIP then
			actor.flags2 = $1|MF2_OBJECTFLIP // flip gravity!
		end
		//If tracer present, point towards it
		if actor.hastracer == true then
			local an = R_PointToAngle2(actor.x, actor.y, actor.tracer.x, actor.tracer.y)
			actor.angle = an
			P_TeleportMove(actor, actor.x + 1*cos(an), actor.y + 1*sin(an), actor.z)
		end
	else
		//If no target, turn invisible
		actor.flags2 = $1|MF2_DONTDRAW
		//Follow tracer and copy its attributes if there is one
		if actor.hastracer == true then
			P_TeleportMove(actor, actor.tracer.x, actor.tracer.y, actor.tracer.z)
			actor.momx = 0
			actor.momy = 0
			actor.momz = 0
			actor.scale = actor.tracer.scale
			if actor.tracer.eflags & MFE_VERTICALFLIP then
				actor.flags2 = $1|MF2_OBJECTFLIP // flip gravity!
			end
		end
	end
end

local function P_PlayerColorSpawn (player)
	if player.powers[pw_super] != 0 then
		return SKINCOLOR_YELLOW
	else
		return player.mo.color
	end
end

// Actually handles the lock-on
addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "modernsonic"
		and player.lockon == "ModernSonic"
		and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		and not (player.gotflag)
			if player.mo.target == nil
			and player.lookedfortarget == 1
				player.lookedfortarget = 0
			end
			if not (player.exiting)
			and not (player.stomping)
				if player.pflags & PF_JUMPED
					if player.lookedfortarget == 0	
						player.lookedfortarget = 1
						player.mo.target = P_LookForEnemies(player)
					end
				end
				if player.pflags & PF_JUMPED
					if player.rettarget == 0 
						if (player.mo.target and player.mo.target.valid and player.mo.target.type ~= MT_RING)
							player.rettarget = player.mo.target
						else
							if (player.mo.target and player.mo.target.valid and player.mo.target.type == MT_RING)
								player.mo.target = nil
								player.rettarget = 0
								player.ret = 0
								player.lookedfortarget = 0
							end
						end
					end
				else
					player.lookedfortarget = 0
					player.rettarget = 0
					if (player.ret) and (player.ret.valid) then
						P_RemoveMobj(player.ret)
						player.ret = 0
					end
				end
				//too far from the target
				local targdist = FixedMul(525*FRACUNIT, player.mo.scale)
				if (player.ret) and (player.ret.valid)
					if (P_AproxDistance(P_AproxDistance(player.mo.x-player.ret.x, player.mo.y-player.ret.y),
					player.mo.z-player.ret.z) > targdist) then
						P_RemoveMobj(player.ret)
						player.ret = 0
						player.rettarget = 0
						player.mo.target = nil
					end
				end
				//not facing the target
				if (player.ret) and (player.ret.valid)
					local angdiff = R_PointToAngle2(player.mo.x, player.mo.y, player.ret.x, player.ret.y) - player.mo.angle
					if ((angdiff > ANGLE_90) or (angdiff < -ANGLE_90))
						P_RemoveMobj(player.ret)
						player.ret = 0
						player.rettarget = 0
						player.mo.target = nil
					end
				end
				//If orb target no longer exists, set the variable to nil
				if (player.rettarget)
					if not (player.rettarget.valid) then
					
						if (player.ret) and (player.ret.valid) then
							P_RemoveMobj(player.ret)
							player.ret = 0
							player.rettarget = 0
						end
					end
				end
				//If orb target no longer has health, set the variable to nil
				if (player.rettarget) and (player.rettarget.valid) then
					if (player.rettarget.health < 1) then
						player.rettarget = 0
						if (player.ret) and (player.ret.valid) then
							P_RemoveMobj(player.ret)
							player.ret = 0
						end
						player.mo.target = nil
					end
				end
				//Stuff to do if there is currently a valid target
				if (player.rettarget) and (player.rettarget.valid) then
					//Add a target reticule if there is none
					if not (player.ret) then
						S_StartSound(player.mo, sfx_homing, player)
						player.ret = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_MODERNRETICLE)
						player.ret.color = P_PlayerColorSpawn(player)
						player.ret.tracer = player.mo
						player.ret.target = player.rettarget
						player.ret.scale = player.ret.target.scale*3/2
					//If there is one, set its color to the player's
					end
				end
				if (player.ret) 
				and player.ret.valid
				and player.ret.target
				and player.ret.target.valid
				and player.ret.target ~= P_LookForEnemies(player)
					player.lookedfortarget = 0
					player.rettarget = 0
					P_RemoveMobj(player.ret)
					player.ret = 0
				end
				if player.ret and player.ret.valid
				and player.ret.target
					if player.ret.scale ~= player.ret.target.scale/3*2
						player.ret.destscale = player.ret.target.scale/3*2
					end
				end
			elseif player.ret and player.ret.valid
				player.lookedfortarget = 0
				player.rettarget = 0
				P_RemoveMobj(player.ret)
				player.ret = 0
			end
			player.dontdisplaymarker = true
		else
			if player.ret and player.ret.valid
				player.lookedfortarget = 0
				player.rettarget = 0
				P_RemoveMobj(player.ret)
				player.ret = 0
			end
			player.dontdisplaymarker = false
		end
	end
end)

//These next 2 hooks get rid of the SRB2 reticle (that redish arrow) and also makes it so only the player locking onto the enemy can see the reticle.
addHook("MobjThinker", function(marker)
  if not marker.valid then return end
  if displayplayer and displayplayer.dontdisplaymarker == true
  or secondarydisplayplayer and secondarydisplayplayer.dontdisplaymarker == true
    marker.flags2 = $ | MF2_DONTDRAW
    return true
  end
end, MT_LOCKON)

addHook("MobjThinker", function(marker)
  if not marker.valid then return end
  if marker ~= displayplayer.ret
    marker.flags2 = $ | MF2_DONTDRAW
    return true
  end
end, MT_MODERNRETICLE)
