function A_SPAWNWALLJUMPOBJECT(actor)
	if not (actor.target and actor.target.player)
		return
	end
	if actor.target.player.walljumptimer == 0
	and not (P_IsObjectOnGround(actor.target))
	and actor.target.player.boosting == false
	and not (actor.target.player.homing)
	and actor.target.player.playerstate == PST_LIVE
		if actor.target.player.powers[pw_super]
			if actor.target.eflags & MFE_UNDERWATER
				P_SetObjectMomZ(actor.target.player.mo, 8*FRACUNIT, false)
			else
				P_SetObjectMomZ(actor.target.player.mo, 16*FRACUNIT, false)
			end
		else
			if actor.target.eflags & MFE_UNDERWATER
				P_SetObjectMomZ(actor.target.player.mo, 6*FRACUNIT, false)
			else
				P_SetObjectMomZ(actor.target.player.mo, 12*FRACUNIT, false)
			end
		end
		if (actor.target.player.mo.eflags & MFE_UNDERWATER)
			S_StartSound(actor.target.player.mo, sfx_jumpwt)
		else
			S_StartSound(actor.target.player.mo, sfx_mjump)
		end
		P_InstaThrust(actor.target.player.mo, actor.target.player.mo.angle, -actor.target.player.actionspd/12)
		actor.target.player.mo.angle = R_PointToAngle2(0, 0, actor.target.player.mo.momx, actor.target.player.mo.momy)
		actor.target.player.drawangle = R_PointToAngle2(0, 0, actor.target.player.mo.momx, actor.target.player.mo.momy)
		actor.target.state = S_PLAY_JUMP
		actor.target.player.walljumptimer = 10
		actor.target.player.jumpdown = true
		if actor.target.player.powers[pw_super] == 0
			actor.target.player.walljumped = true
		end
		actor.target.player.doublejumped = true
		actor.target.player.pflags = $1|PF_JUMPED
		actor.target.player.pflags = $1|PF_THOKKED
		actor.target.player.normalspeed = 36*FRACUNIT
	end
end

//The Walljump Process.

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "modernsonic")
		and not (player.powers[pw_carry] == CR_NIGHTSMODE) 
			if player.mo.state == S_PLAY_SPRING
				player.airboost = false
			end
			if not (player.cmd.buttons & BT_JUMP)
				player.spawnwalljump = false
				player.jumpdown = false
			end
			if player.walljumptimer > 0
				player.walljumptimer = $1-1
			end
			if not (P_IsObjectOnGround(player.mo))
			and not (P_PlayerInPain(player))
			and player.spawnwalljump == false
			and player.cmd.buttons & BT_JUMP
			and not (player.pflags & PF_JUMPED)
				player.spawnwalljump = true
				local walljump = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_WALLJUMP)
				walljump.target = player.mo
				walljump.scale = player.mo.scale
			end
			if (player.mo.state == S_PLAY_WALLJUMP or player.mo.state == S_PLAY_JUMP)
			and player.walljumped == true
				if player.mo.eflags & MFE_VERTICALFLIP 
				and player.mo.momz > 0
				or not (player.mo.eflags & MFE_VERTICALFLIP) 
				and player.mo.momz < 0
					player.mo.state = S_PLAY_FALL
				end
			end
			if P_IsObjectOnGround(player.mo)
				player.walljumped = false
			end
			if player.walljumped == true
			and player.mo.state == S_PLAY_HOP
				player.mo.state = S_PLAY_JUMP
			end
		end
	end
end)